import {
  CodeTokenBuilder,
  CodeTokenProps,
  CodeTokenType,
  DistributiveOmit,
} from "../types";

export const createToken = new Proxy(
  {},
  {
    get: (_, prop: CodeTokenType) => {
      const builder = <T extends React.ElementType = React.ElementType>(
        children: CodeTokenProps<T>["children"],
        props: DistributiveOmit<CodeTokenProps<T>, "type">
      ): CodeTokenProps<T> =>
        {
          return {
            type: prop,
            children,
            ...props,
          };
        };
      return builder;
    },
  }
) as Record<CodeTokenType, CodeTokenBuilder>;

export const whiteSpace = (count: number = 1): CodeTokenProps => ({
  type: "default",
  children: " ".repeat(count),
});
